package com.fireworksdk.bridge.flutter.pages

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.FragmentActivity
import androidx.fragment.app.FragmentManager
import com.fireworksdk.bridge.R
import com.fireworksdk.bridge.flutter.FireworkFlutterSdkPlugin
import com.fireworksdk.bridge.flutter.constants.FWFlutterConstant
import io.flutter.embedding.android.FlutterFragment
import java.io.Serializable

class FWContainerActivity : FragmentActivity() {

  private var flutterFragment: FlutterFragment? = null

  override fun onCreate(savedInstanceState: Bundle?) {
    super.onCreate(savedInstanceState)
    setContentView(R.layout.fw_bridge_fragment_container)

    val map = intent.getSerializableExtra(KEY_PARAM_MAP) as Map<String, Any?>?

    val fragmentManager: FragmentManager = supportFragmentManager

    flutterFragment = fragmentManager
      .findFragmentByTag(FWFlutterConstant.TAG_FLUTTER_FRAGMENT) as FlutterFragment?

    if (null == flutterFragment) {

      val newFlutterFragment = FireworkFlutterSdkPlugin.containerFragmentDelegate?.getFragment(this, map)
      flutterFragment = newFlutterFragment

      if (null != newFlutterFragment) {
        fragmentManager
          .beginTransaction()
          .add(
            R.id.fw_bridge_container,
            newFlutterFragment,
            FWFlutterConstant.TAG_FLUTTER_FRAGMENT
          )
          .commit()
      }
    }

  }

  companion object {
    private const val KEY_PARAM_MAP = "param_map"

    fun createIntent(activity: Activity, map: Map<String, Any?>?): Intent {
      val intent = Intent(activity, FWContainerActivity::class.java)
      intent.putExtra(KEY_PARAM_MAP, map as Serializable?)
      intent.flags = Intent.FLAG_ACTIVITY_NO_ANIMATION
      activity.overridePendingTransition(0, 0)
      return intent
    }
  }

}
