package com.fireworksdk.bridge.flutter.pages

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.fragment.app.FragmentActivity
import androidx.fragment.app.FragmentManager
import com.fireworksdk.bridge.R
import com.fireworksdk.bridge.flutter.FireworkFlutterSdkPlugin
import com.fireworksdk.bridge.flutter.constants.FWFlutterConstant
import io.flutter.embedding.android.FlutterFragment


class FWVideoShoppingCartActivity : FragmentActivity() {

  private var flutterFragment: FlutterFragment? = null

  override fun onCreate(savedInstanceState: Bundle?) {
    super.onCreate(savedInstanceState)
    setContentView(R.layout.fw_bridge_fragment_shoppingcart)

    val fragmentManager: FragmentManager = supportFragmentManager

    flutterFragment = fragmentManager
      .findFragmentByTag(FWFlutterConstant.TAG_FLUTTER_FRAGMENT) as FlutterFragment?

    if (null == flutterFragment) {

      val newFlutterFragment = FireworkFlutterSdkPlugin.cartFragmentDelegate?.getFragment(this, null)
      flutterFragment = newFlutterFragment

      if (null != newFlutterFragment) {
        fragmentManager
          .beginTransaction()
          .add(
            R.id.fw_bridge_shopping_cart_container,
            newFlutterFragment,
            FWFlutterConstant.TAG_FLUTTER_FRAGMENT
          )
          .commit()
      }
    }

  }

  companion object {

    fun createIntent(activity: Activity): Intent {
      val intent = Intent(activity, FWVideoShoppingCartActivity::class.java)
      intent.flags = Intent.FLAG_ACTIVITY_NO_ANIMATION
      activity.overridePendingTransition(0, 0)
      return intent
    }
  }

}
