package com.fireworksdk.bridge.models

import android.os.Parcelable
import kotlinx.android.parcel.Parcelize

@Parcelize
data class FWVideoShoppingProduct(
  val productId: String?,
  val name: String?,
  val description: String?,
  val units: List<FWVideoProductUnit>?
) : Parcelable {

  @Parcelize
  data class FWVideoProductUnit(
    val unitId: String?,
    val name: String?,
    val price: FWVideoProductPrice?,
    val url: String?,
    val options: List<FWVideoProductOption>?
  ) : Parcelable

  @Parcelize
  data class FWVideoProductPrice(
    val amount: Double?,
    val currencyCode: String?
  ) : Parcelable

  @Parcelize
  data class FWVideoProductOption(
    val name: String?,
    val value: String?
  ) : Parcelable
}
