//
//  RCTConvert+FWVideoFeed.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/22.
//

import Foundation
import FireworkVideo

extension VideFeedSourceType {
    static var feedTypeMapper: [String: VideFeedSourceType] {
        ["discover": .discover,
         "channel": .channel,
         "playlist": .playlist,
         "playlistGroup": .playlistGroup,
         "dynamicContent": .dynamicContent]
    }
}

extension VideoFeedMode {
    static var feedModeMapper: [String: VideoFeedMode] {
        ["row": .row,
         "column": .colume,
         "grid": .grid]
    }
}

@objc
public extension RCTConvert {
    static func videoFeedSourceType(_ type: String?) -> VideFeedSourceType {
        guard let rType = type else {
            return .discover
        }
        
        return VideFeedSourceType.feedTypeMapper[rType] ?? .discover
    }
    
    static func videoFeedMode(_ type: String?) -> VideoFeedMode {
        guard let rType = type else {
            return .row
        }
        
        return VideoFeedMode.feedModeMapper[rType] ?? .row
    }
}
