//
//  FireworkJsEvent.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/21.
//

import Foundation

/// Video event
enum FWEventName: String, CaseIterable {
  case SDKInit = "fw:sdk-init"
  case CustomCTAClick = "fw:custom-cta-click"
  case VideoPlayback = "fw:video-playback"
  case VideoFeedClick = "fw:video-feed-click"
}

enum VideoPlaybackSubEventName: String {
    case Impression = "fw:video:impression"
    case Start = "fw:video:start"
    case FirstQuartile = "fw:video:first-quartile"
    case Midpoint = "fw:video:midpoint"
    case ThirdQuartile = "fw:video:third-quartile"
    case Complete = "fw:video:complete"
    case AdEnd = "fw:video:ad-end"
    case ClickCTA = "fw:video:click-cta"
    case ClickShare = "fw:video:click-share"
}

/// Shopping event
enum ShoppingEventName: String, CaseIterable {
    case UpdateProductDetails = "fw:shopping:update-product-details"
    case WillDisplayProduct = "fw:shopping:will-display-product"
    case AddToCart = "fw:shopping:add-to-cart"
    case ClickCartIcon = "fw:shopping:click-cart-icon"
}

/// Live stream event
enum LiveStreamEventName: String, CaseIterable {
  case livestream = "fw:livestream"
  case livestreamChat = "fw:livestream-chat"
}

enum LiveStreamSubEventName: String {
  case UserDidjoin = "fw:livestream:user-join"
  case UserDidLeave = "fw:livestream:user-leave"
  case UserSendLike = "fw:livestream:user-send-like"
}

enum LiveStreamChatSubEventName: String {
  case UserSendChat = "fw:livestream:user-send-chat"
}
