//
//  FireworkSDKModulePlugin.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2022/2/21.
//

import Foundation
import Flutter

class FireworkFlutterModulePlugin: NSObject, FlutterPlugin {
 
    var channel: FlutterMethodChannel! = nil
    
    static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: FWChannelName.FireworkFlutterSdk.rawValue, binaryMessenger: registrar.messenger())
        let instance = FireworkFlutterModulePlugin()
        instance.channel = channel
        registrar.addMethodCallDelegate(instance, channel: channel)
        
        BroadcastAdapter.share.addAdaptee(channel) { adaptee, methodName, arguments in
            adaptee.invokeMethod(methodName, arguments: arguments)
        }
    }
    
    func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        BroadcastAdapter.share.invokeMethod(call.method, arguments: call.arguments)
        result(nil)
    }
}
