//
//  FireworkSdk+EventTracking.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/21.
//

import Foundation
import FireworkVideo

extension FireworkSDKModulePlugin: FireworkVideoPlaybackDelegate {
    func fireworkVideoDidPause(_ videoPlayback: VideoPlaybackDetails) {
        
    }
    
    func fireworkVideoDidResume(_ videoPlayback: VideoPlaybackDetails) {
        
    }
    
    func fireworkVideoDidRecordImpression(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName": VideoPlaybackSubEventName.Impression.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoDidStartPlaying(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.Start.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoReachedFirstQuartile(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.FirstQuartile.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoReachedMidPoint(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.Midpoint.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoReachedThirdQuartile(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.ThirdQuartile.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoDidFinishPlaying(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.Complete.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoDidTapCTAButton(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.ClickCTA.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoDidTapShareButton(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.ClickShare.rawValue, "info": videoPlayback.jsObject])
    }
    
    func fireworkVideoDidStartPlayingAd(_ videoPlayback: VideoPlaybackDetails) {
   
    }
    
    func fireworkVideoDidFinishPlayingAd(_ videoPlayback: VideoPlaybackDetails) {
        guard enableVideoPlayBackEvent else { return }
        
        channel.invokeMethod(FWEventName.VideoPlayback.rawValue, arguments: ["eventName":VideoPlaybackSubEventName.AdEnd.rawValue, "info": videoPlayback.jsObject])
    }
}

extension FireworkSDKModulePlugin: FireworkVideoFeedDelegate {
    
    func fireworkVideoDidTapThumbnail(_ eventDetails: FeedEventDetails) {
        channel.invokeMethod(FWEventName.VideoFeedClick.rawValue, arguments: ["info": eventDetails.jsObject])
    }
}
