//
//  CartViewController.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/31.
//

import UIKit
import FireworkVideo
import Flutter

class CartViewController: UIViewController, CartViewRepresentable {
    var indicator: UIActivityIndicatorView? = nil
//    var callbackId: Int!
//    var directShowCartPage = false
//    var entryPoint: String = ""
//    var libraryURI: String?
//    var initialRoute: String?
    
    init(callbackId: Int) {
//        self.callbackId = callbackId
        
        super.init(nibName: nil, bundle: nil)
        
//        NotificationCenter.default.addObserver(self, selector: #selector(showCustomCartView), name: Notification.Name(rawValue: "showCustomCartView"), object: nil)
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)

        self.navigationController?.setNavigationBarHidden(true, animated: true)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()

//        if directShowCartPage {
//            directShowCustomCartView()
//        } else {
            setupIndicatorView()
//        }
        
        directShowCustomCartView()
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)

        
        self.navigationController?.setNavigationBarHidden(false, animated: true)
    }
    
//    @objc func showCustomCartView(_ noti: NSNotification) {
//        guard let cbId = noti.userInfo?["cbid"] as? Int, callbackId == cbId  else {
//            return
//        }
//        guard let entry = noti.userInfo?["entryPointName"] as? String else {
//            print("Flutter engine entry point name can not empty!")
//            return
//        }
//
//        self.entryPoint = entry
//        self.libraryURI = noti.userInfo?["libraryURI"] as? String
//        self.initialRoute = noti.userInfo?["initialRoute"] as? String
//
//        if isViewLoaded {
//            directShowCustomCartView()
//        } else {
//            directShowCartPage = true
//        }
//    }
    
    private func setupIndicatorView() {
        let indicator = UIActivityIndicatorView(frame: .zero)
        if #available(iOS 13.0, *) {
            indicator.style = .large
        } else {
            indicator.style = .whiteLarge
        }
        indicator.color = UIColor.white
        view.addSubview(indicator)
        indicator.translatesAutoresizingMaskIntoConstraints = false

        NSLayoutConstraint.activate([
            indicator.centerXAnchor.constraint(equalTo: view.centerXAnchor),
            indicator.centerYAnchor.constraint(equalTo: view.centerYAnchor)
        ])
        
        indicator.startAnimating()
        
        self.indicator = indicator
    }
    
    private func directShowCustomCartView() {
        indicator?.stopAnimating()
        
        guard let customCartPageProvider = SwiftFireworkFlutterSdkPlugin.customCartPageProvider else {
            print("Not implement customCartPageProvdier!")
            return
        }

        let flutterVC = customCartPageProvider()
        let flutterRootView: UIView! = flutterVC.view
        flutterRootView.translatesAutoresizingMaskIntoConstraints = false

        self.addChild(flutterVC)
        view.addSubview(flutterRootView)
        NSLayoutConstraint.activate([
            flutterRootView.leftAnchor.constraint(equalTo: view.leftAnchor),
            flutterRootView.topAnchor.constraint(equalTo: view.topAnchor),
            flutterRootView.rightAnchor.constraint(equalTo: view.rightAnchor),
            flutterRootView.bottomAnchor.constraint(equalTo: view.bottomAnchor)
        ])
        
        flutterVC.didMove(toParent: self)
    }
}
