//
//  Product.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/30.
//

import Foundation

struct Product: Codable {
    var productId: String
    var name: String?
    var description: String?
    var units: [ProductUnit]?
    
    struct ProductUnit: Codable {
        var unitId: String
        var name: String?
        var price: Price?
        var url: String?
        var options: [VariantOption]?
    }
    
    struct Price: Codable {
        var amount: Double?
        var currencyCode: String?
    }
    
    struct VariantOption: Codable, Equatable {
        var name: String?
        var value: String?
    }
}
