//
//  VideoFeedConfiguration.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/28.
//

import Foundation

@objc
public class VideoFeedConfiguration: NSObject, Codable {
    var backgroundColor: String?
    var cornerRadius: Int?
    var title: VideoFeedTitleConfiguration?
    var titlePosition: VideoFeedTitlePosition?
    var playIcon: VideoFeedPlayIconConfiguration?
    var showSponsored: Bool?
    var showAdBadge: Bool?

    class VideoFeedTitleConfiguration: NSObject, Codable {
        public var hidden: Bool?
        public var textColor: String?
        public var fontSize: Int?
    }

    class VideoFeedPlayIconConfiguration: NSObject, Codable {
        public var hidden: Bool?
        public var iconWidth: Int?
    }
    
    enum VideoFeedTitlePosition: String, Codable {
        case stacked, nested
    }
}
