//
//  VideoPlayerConfiguration.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/28.
//

import Foundation

@objc
public class VideoPlayerConfiguration: NSObject, Codable {
    var playerStyle: VideoPlayerStyle?
    var videoCompleteAction: VideoPlayerCompleteAction?
    var showShareButton: Bool?
    var ctaButtonStyle: VideoPlayerCTAStyle?
    var showPlaybackButton: Bool?
    var showMuteButton: Bool?
    var launchBehavior: VideoLaunchBehavior?

    public enum VideoPlayerStyle: String, Codable {
        case full, fit
    }

    public enum VideoPlayerCompleteAction: String, Codable {
        case loop, advanceToNext
    }

    public class VideoPlayerCTAStyle: NSObject, Codable {
        var backgroundColor: String?
        var textColor: String?
        var fontSize: Int?
    }
    public enum VideoLaunchBehavior: String, Codable {
        case `default`, muteOnFirstLaunch
    }
}
