//
//  File.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2022/2/21.
//

import Foundation
import Flutter

@objc(SwiftFireworkFlutterSdkPlugin)
public class SwiftFireworkFlutterSdkPlugin: NSObject, FlutterPlugin {
    
    /// The host app need to set to this property. when use click cart icon on shoppable video, fireworksdk will call this property to push cart page.
    public static var customCartPageProvider: (() -> FlutterViewController)?
    
    /// Description
    public static var navigatorPageProvider: ((Dictionary<String, Any>?) -> FlutterViewController?)?

    public static func register(with registrar: FlutterPluginRegistrar) {
        FireworkSDKModulePlugin.register(with: registrar)
        ShoppingModulePlugin.register(with: registrar)
        LiveStreamModulePlugin.register(with: registrar)
        FireworkFlutterModulePlugin.register(with: registrar)
        FireworkNavigatorModule.register(with: registrar)
        
        let factory = VideoFeedViewFactory(messenger: registrar.messenger())
        registrar.register(factory, withId: FWChannelName.FireworkVideoFeed.rawValue)
    }
    
}
