//
//  UIViewController.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2022/2/21.
//

import UIKit

extension UIViewController {
    
    static func presentedViewController() -> UIViewController? {
        var controller = keyWindow()?.rootViewController;
        var presentedController = controller?.presentedViewController;
        while let isBeingDismissed = presentedController?.isBeingDismissed, !isBeingDismissed && presentedController != nil {
            controller = presentedController;
            presentedController = controller?.presentedViewController;
        }

        return controller;
    }
    
    static private func sharedApplication() -> UIApplication {
        return UIApplication.shared
    }

    static private func keyWindow() -> UIWindow? {
        if (runningInAppExtension()) {
            return nil;
        }

        // TODO: replace with a more robust solution
        for window in sharedApplication().windows {
            if (window.isKeyWindow) {
                return window;
            }
        }
        
        return nil;
    }
    
    static private func runningInAppExtension() -> Bool {
        return Bundle.main.bundlePath.hasSuffix(
        "appex")
    }
}
