import 'package:fw_flutter_sdk/src/models/fw_method_name.dart';
import 'package:fw_flutter_sdk/src/utils/fw_method_channel_util.dart';
import 'package:fw_flutter_sdk/src/utils/model_utils/fw_method_name_util.dart';

class FWNavigator {
  static FWNavigator? _instance;

  static FWNavigator _getInstance() {
    _instance ??= FWNavigator._();
    return _instance!;
  }

  FWNavigator._();

  factory FWNavigator.getInstance() => _getInstance();

  Future<bool> pushNativeContainer(Map<String, dynamic>? arguments) async {
    final result =
        await FWMethodChannelUtil.getNavigatorMethodChannel().invokeMethod(
      FWNavigatorMethodNameUtil.convertToNativeMethod(
        FWNavigatorNativeMethodName.pushNativeContainer,
      ),
      arguments,
    );
    return result;
  }

  Future<bool> popNativeContainer() async {
    final result =
        await FWMethodChannelUtil.getNavigatorMethodChannel().invokeMethod(
      FWNavigatorMethodNameUtil.convertToNativeMethod(
        FWNavigatorNativeMethodName.popNativeContainer,
      ),
    );
    return result;
  }
}
