import 'video_feed_source.dart';

class FeedItemDetails {
  /// The index of the thumbnail tapped in the feed.
  int? index;

  /// The unique id of the thumbnail.
  /// If the source is `playlistGroup` this value will represent the playlist's id; otherwise this value is the id of the selected video
  String id;

  /// The total duration of the video.
  /// If the source is `playlistGroup` this value will always be 0; otherwise this value is the duration of the selected video.
  double? duration;

  /// The content source of the feed.
  VideoFeedSource source;

  FeedItemDetails({
    this.index,
    required this.id,
    this.duration,
    required this.source,
  });
}
