class Product {
  /// A unique identifier of the product.
  String productId;

  /// The name of the product.
  String? name;

  /// The description of the product.
  String? description;

  /// The unit array of the product
  List<ProductUnit>? units;

  Product({
    required this.productId,
    this.name,
    this.description,
    this.units,
  });
}

class ProductUnit {
  /// The unique identifier of the product unit.
  String unitId;

  /// The name of the product unit.
  String? name;

  /// The url of the product unit.
  String? url;

  /// The price of the product unit.
  ProductPrice? price;

  ProductUnit({
    required this.unitId,
    this.name,
    this.url,
    this.price,
  });
}

class ProductPrice {
  double amount;
  String currencyCode;

  ProductPrice({
    required this.amount,
    required this.currencyCode,
  });
}
