class VideoPlayerSize {
  double width;
  double height;
  VideoPlayerSize({
    required this.width,
    required this.height,
  });
}

class VideoPlaybackDetails {
  /// A unique identifier of the video.
  String videoId;

  /// The total duration of the video.
  double? duration;

  /// The caption for the video.
  String? caption;

  /// Video badge type.
  String? badge;

  /// The size of the player.
  VideoPlayerSize? playerSize;

  /// Indicates if the video is associated with a call-to-action (CTA).
  bool? hasCTA;

  VideoPlaybackDetails({
    required this.videoId,
    this.duration,
    this.caption,
    this.badge,
    this.playerSize,
    this.hasCTA,
  });
}

enum VideoPlaybackEventName {
  /// When video is shown to the user.
  impression,

  /// Video started.
  start,

  /// Video reached 25%.
  firstQuartile,

  /// Video reached 50%.
  midpoint,

  /// Video reached 75%.
  thirdQuartile,

  /// Video reached 100%.
  complete,

  /// When ad video finishes playing.
  adEnd,

  /// When a visitor clicks on CTA button (if available).
  clickCTA,

  /// When user clicks on "Share" button.
  clickShare,
}
