import '../../models/ad_badge_configuration.dart';

class AdBadgeConfigurationUtil {
  static String convertBadgeTextTypeToRawType(AdBadgeTextType? type) {
    if (type == null) {
      return "";
    }
    String rawType = "";
    switch (type) {
      case AdBadgeTextType.ad:
        rawType = "ad";
        break;
      case AdBadgeTextType.sponsored:
        rawType = "sponsored";
        break;
    }

    return rawType;
  }

  static Map<String, dynamic> toJson(AdBadgeConfiguration config) {
    Map<String, dynamic> json = {};
    String rawBadgeTextType =
        convertBadgeTextTypeToRawType(config.badgeTextType);
    if (rawBadgeTextType.isNotEmpty) {
      json["badgeTextType"] = rawBadgeTextType;
    }

    if (config.backgroundColor != null && config.backgroundColor!.isNotEmpty) {
      json["backgroundColor"] = config.backgroundColor!;
    }

    if (config.textColor != null && config.textColor!.isNotEmpty) {
      json["textColor"] = config.textColor!;
    }
    return json;
  }
}
