import '../../models/feed_item_details.dart';
import 'video_feed_source_util.dart';

class FeedItemDetailsUtil {
  static FeedItemDetails? fromJson(dynamic json) {
    if (json is Map<dynamic, dynamic>) {
      if (json["source"] is String) {
        final source =
            VideoFeedSourceUtil.createFeedSource(json["source"] as String);
        if (source != null && json["id"] is String) {
          FeedItemDetails details =
              FeedItemDetails(id: json["id"] as String, source: source);

          if (json["index"] is int) {
            details.index = json["index"] as int;
          }

          if (json["duration"] is num) {
            details.duration = (json["duration"] as num).toDouble();
          }

          return details;
        }
      }
    }

    return null;
  }
}
