import '../../models/live_stream_message_details.dart';

const liveStreamChatEventNameMap = <String, LiveStreamChatEventName>{
  "fw:livestream:user-send-chat": LiveStreamChatEventName.userSendChat,
};

class LiveStreamMessageDetailsUtil {
  static LiveStreamMessageDetails? fromJson(dynamic json) {
    if (json is Map<dynamic, dynamic>) {
      if (json["messageId"] is String) {
        final messageId = json["messageId"] as String;
        final details = LiveStreamMessageDetails(
          messageId: messageId,
        );

        if (json["username"] is String) {
          details.username = json["username"] as String;
        }

        if (json["text"] is String) {
          details.text = json["text"] as String;
        }

        return details;
      }
    }
    return null;
  }

  static LiveStreamChatEventName? createLiveStreamChatEventName(
      String rawName) {
    final eventName = liveStreamChatEventNameMap[rawName];
    return eventName;
  }
}
