import '../../models/product.dart';

class ProductUtil {
  static Map<String, dynamic> _converProductUnitToJson(ProductUnit unit) {
    Map<String, dynamic> json = {};
    json["unitId"] = unit.unitId;
    if (unit.name != null) {
      json["name"] = unit.name;
    }

    if (unit.url != null) {
      json["url"] = unit.url;
    }

    if (unit.price != null) {
      json["price"] = <String, dynamic>{
        "amount": unit.price!.amount,
        "currencyCode": unit.price!.currencyCode,
      };
    }

    return json;
  }

  static Map<String, dynamic> toJson(Product product) {
    Map<String, dynamic> json = {};
    json["productId"] = product.productId;

    if (product.name != null) {
      json["name"] = product.name;
    }

    if (product.description != null) {
      json["description"] = product.description;
    }

    if (product.units != null) {
      final unitListJson =
          product.units!.map((e) => _converProductUnitToJson(e)).toList();
      json["units"] = unitListJson;
    }

    return json;
  }
}
