import '../../models/video_feed_configuration.dart';

class VideoFeedConfigurationUtil {
  static Map<String, dynamic> _convertTitleConfigToJson(
      VideoFeedTitleConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.hidden != null) {
      json["hidden"] = config.hidden!;
    }

    if (config.textColor != null && config.textColor!.isNotEmpty) {
      json["textColor"] = config.textColor!;
    }

    if (config.fontSize != null) {
      json["fontSize"] = config.fontSize!.toDouble();
    }
    return json;
  }

  static String convertToRawTitlePosition(VideoFeedTitlePosition position) {
    String rawTitlePosition = "";
    switch (position) {
      case VideoFeedTitlePosition.stacked:
        rawTitlePosition = "stacked";
        break;
      case VideoFeedTitlePosition.nested:
        rawTitlePosition = "nested";
        break;
    }
    return rawTitlePosition;
  }

  static Map<String, dynamic> _convertPlayIconConfigToJson(
      VideoFeedPlayIconConfiguration config) {
    Map<String, dynamic> json = {};
    if (config.hidden != null) {
      json["hidden"] = config.hidden!;
    }

    if (config.iconWidth != null) {
      json["iconWidth"] = config.iconWidth!.toDouble();
    }
    return json;
  }

  static Map<String, dynamic> toJson(VideoFeedConfiguration config) {
    Map<String, dynamic> json = {};

    if (config.backgroundColor != null && config.backgroundColor!.isNotEmpty) {
      json["backgroundColor"] = config.backgroundColor!;
    }

    if (config.cornerRadius != null) {
      json["cornerRadius"] = config.cornerRadius!.toDouble();
    }

    if (config.title != null) {
      json["title"] = _convertTitleConfigToJson(config.title!);
    }

    if (config.titlePosition != null) {
      json["titlePosition"] = convertToRawTitlePosition(config.titlePosition!);
    }

    if (config.playIcon != null) {
      json["playIcon"] = _convertPlayIconConfigToJson(config.playIcon!);
    }

    if (config.showAdBadge != null) {
      json["showAdBadge"] = config.showAdBadge!;
    }

    if (config.customLayoutName != null) {
      json["customLayoutName"] = config.customLayoutName!;
    }

    return json;
  }
}
