import '../../models/video_feed_source.dart';

class VideoFeedSourceUtil {
  static String convertToRawFeedSource(VideoFeedSource source) {
    String rawSource = "";
    switch (source) {
      case VideoFeedSource.discover:
        rawSource = "discover";
        break;
      case VideoFeedSource.channel:
        rawSource = "channel";
        break;
      case VideoFeedSource.playlist:
        rawSource = "playlist";
        break;
      case VideoFeedSource.playlistGroup:
        rawSource = "playlistGroup";
        break;
      case VideoFeedSource.dynamicContent:
        rawSource = "dynamicContent";
        break;
    }
    return rawSource;
  }

  static VideoFeedSource? createFeedSource(String rawSource) {
    VideoFeedSource? source;

    switch (rawSource) {
      case "discover":
        source = VideoFeedSource.discover;
        break;
      case "channel":
        source = VideoFeedSource.channel;
        break;
      case "playlist":
        source = VideoFeedSource.playlist;
        break;
      case "playlistGroup":
        source = VideoFeedSource.playlistGroup;
        break;
      case "dynamicContent":
        source = VideoFeedSource.dynamicContent;
        break;
    }
    return source;
  }
}
